'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _memoizeOne = require('memoize-one');

var _memoizeOne2 = _interopRequireDefault(_memoizeOne);

var _getDraggablesInsideDroppable = require('./get-draggables-inside-droppable');

var _getDraggablesInsideDroppable2 = _interopRequireDefault(_getDraggablesInsideDroppable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getIndex = (0, _memoizeOne2.default)(function (draggables, target) {
  return draggables.indexOf(target);
});

exports.default = function (_ref) {
  var isMovingForward = _ref.isMovingForward,
      draggableId = _ref.draggableId,
      location = _ref.location,
      draggables = _ref.draggables,
      droppables = _ref.droppables;

  var droppable = droppables[location.droppableId];
  var draggable = draggables[draggableId];
  var currentIndex = location.index;

  var insideDroppable = (0, _getDraggablesInsideDroppable2.default)(droppable, draggables);

  var startIndex = getIndex(insideDroppable, draggable);

  if (startIndex === -1) {
    console.error('could not find draggable inside current droppable');
    return null;
  }

  if (isMovingForward && currentIndex === insideDroppable.length - 1) {
    return null;
  }

  if (!isMovingForward && currentIndex === 0) {
    return null;
  }

  var atCurrentIndex = insideDroppable[currentIndex];
  var nextIndex = isMovingForward ? currentIndex + 1 : currentIndex - 1;
  var atNextIndex = insideDroppable[nextIndex];

  var isMovingTowardStart = isMovingForward && nextIndex <= startIndex || !isMovingForward && nextIndex >= startIndex;

  var amount = isMovingTowardStart ? atCurrentIndex.page.withMargin.height : atNextIndex.page.withMargin.height;

  var diff = {
    x: 0,
    y: isMovingForward ? amount : -amount
  };

  return diff;
};