'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _position = require('./position');

exports.default = function (_ref) {
  var movement = _ref.movement,
      clientOffset = _ref.clientOffset,
      pageOffset = _ref.pageOffset,
      droppableScrollDiff = _ref.droppableScrollDiff,
      windowScrollDiff = _ref.windowScrollDiff,
      draggables = _ref.draggables;

  if (!movement.draggables.length) {
    return (0, _position.add)(droppableScrollDiff, windowScrollDiff);
  }

  var distance = movement.draggables.reduce(function (previous, draggableId) {
    var dimension = draggables[draggableId];
    return previous + dimension.page.withMargin.height;
  }, 0);

  var amount = movement.isMovingForward ? distance : -distance;

  var verticalChange = {
    x: 0,
    y: amount
  };

  var verticalDiff = (0, _position.subtract)(verticalChange, pageOffset);

  var client = (0, _position.add)(verticalDiff, clientOffset);

  var withScroll = (0, _position.add)(client, droppableScrollDiff);

  return withScroll;
};